from devtools import Debug, PrettyFormat
from devtools import sformat as fm
from devtools.debug import DebugArgument
from devtools.utils import is_literal


def arg_format(a: DebugArgument) -> str:
  s = ''
  if a.name and not is_literal(a.name):
    s = f'{fm(a.name, fm.blue, fm.bold)} '

  s += PrettyFormat(indent_step=2)(a.value, highlight=True)
  s += fm(f' {a.value.__class__.__name__}{"".join(f" {k}={v}" for k, v in a.extra)}', fm.dim)
  return s


class Output:
  arg_class = DebugArgument

  def __init__(
    self,
    *,
    filename: None,
    lineno: None,
    frame: None,
    arguments: list[DebugArgument],
    warning: None,
  ) -> None:
    self.arguments = arguments
    _ = filename, lineno, frame, warning

  def str(self, _: None) -> str:
    return '\n'.join(arg_format(a) for a in self.arguments)


p = Debug()
p.output_class = Output
